#ifndef BatchLab_LinkFolder_h
#define BatchLab_LinkFolder_h

// Inheritance :
#include <BatchLab/Core/BaseFolder.h>

namespace BatchLab {

class LinkFolder : public BaseFolder {
public: //Slash::Store::IFolder
  virtual void* cast(const std::string&) const;
  virtual void add(Slash::Store::IObject*);
  virtual void remove(Slash::Store::IObject*);
  virtual void add(Slash::Store::IFolder*);
  virtual void remove(Slash::Store::IFolder*);
  virtual bool link(Slash::Store::IFolder*,const std::string&);
  virtual bool unlink(Slash::Store::IFolder*);
  virtual void clear();
  virtual Slash::Store::IFolder* mkdir(const std::string&);
  virtual Slash::Store::IObjectIterator* objects() const;
  virtual Slash::Store::IFolderIterator* folders() const;
public:
  LinkFolder(Slash::Core::IWriter&,Slash::Store::IFolder*,const std::string&,Slash::Store::ITree&,Slash::Store::IFolder*);
  virtual ~LinkFolder();
  Slash::Store::IFolder* linkedFolder() const;
  void setLinkedFolder(Slash::Store::IFolder*);
  virtual bool isSymlink();
private:
  Slash::Store::IFolder* fLinkedFolder;
};

}

#endif
