SETLOCAL

REM #
REM #  Sourced by the build.bat script in case of 
REM # using a osc_vis kit and then have to rebuild
REM # the G4LabCore and G4LabUIOnX libraries.
REM #
REM #  This script assumes that the variables
REM # compiler, g4_incs and g4_libs had been defined in the
REM # calling build.bat script.
REM #

REM #//////////////////////////////////////////////////
REM #// library G4LabCore :
REM #//////////////////////////////////////////////////
SET cppflags=%def_cppflags%
SET cppflags=%cppflags% /I..\source%
SET cppflags=%cppflags% %onx_cppflags%
SET cppflags=%cppflags% %onx_iv_cppflags%
SET cppflags=%cppflags% %aida_cppflags%
SET cppflags=%cppflags% %g4_incs%

SET src=..\source\G4Lab\cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_BestUnit.obj /Tp%src%\BestUnit.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_Transform3D.obj /Tp%src%\Transform3D.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_Polyhedron.obj /Tp%src%\Polyhedron.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_GeometryVisitor.obj /Tp%src%\GeometryVisitor.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_Tree.obj /Tp%src%\Tree.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_Trajectory.obj /Tp%src%\Trajectory.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_State.obj /Tp%src%\State.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_SteppingAction.obj /Tp%src%\SteppingAction.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_TrackingAction.obj /Tp%src%\TrackingAction.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_SoG4RunManager.obj /Tp%src%\SoG4RunManager.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_SoVisitedVolume.obj /Tp%src%\SoVisitedVolume.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_SoG4Trajectories.obj /Tp%src%\SoG4Trajectories.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_PhysicalVolumeAccessor.obj /Tp%src%\PhysicalVolumeAccessor.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_TrajectoryContainerAccessor.obj /Tp%src%\TrajectoryContainerAccessor.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_TrajectoryAccessor.obj /Tp%src%\TrajectoryAccessor.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_PhysicsTableAccessor.obj /Tp%src%\PhysicsTableAccessor.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_HitsCollectionAccessor.obj /Tp%src%\HitsCollectionAccessor.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_DigitsCollectionAccessor.obj /Tp%src%\DigitsCollectionAccessor.cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_Manager.obj /Tp%src%\Manager.cxx

SET objs=%bin%\G4Lab_BestUnit.obj %bin%\G4Lab_Transform3D.obj %bin%\G4Lab_Polyhedron.obj %bin%\G4Lab_GeometryVisitor.obj %bin%\G4Lab_Tree.obj %bin%\G4Lab_State.obj %bin%\G4Lab_SteppingAction.obj %bin%\G4Lab_TrackingAction.obj %bin%\G4Lab_SoG4RunManager.obj %bin%\G4Lab_SoVisitedVolume.obj %bin%\G4Lab_SoG4Trajectories.obj %bin%\G4Lab_PhysicalVolumeAccessor.obj %bin%\G4Lab_TrajectoryContainerAccessor.obj %bin%\G4Lab_Trajectory.obj %bin%\G4Lab_TrajectoryAccessor.obj %bin%\G4Lab_PhysicsTableAccessor.obj %bin%\G4Lab_HitsCollectionAccessor.obj %bin%\G4Lab_DigitsCollectionAccessor.obj %bin%\G4Lab_Manager.obj

lib.exe /nologo /machine:ix86 /out:G4LabCore.lib %objs%

DEL %objs%

REM #//////////////////////////////////////////////////
REM # library G4LabUIOnX
REM #//////////////////////////////////////////////////
SET cppflags=%def_cppflags%
SET cppflags=%cppflags% /I..\source%
SET cppflags=%cppflags% %onx_cppflags%
SET cppflags=%cppflags% %g4_incs%

SET src=..\source\G4Lab\cxx
cl.exe /c %cppflags% /Fo%bin%\G4Lab_UIOnX.obj /Tp%src%\UIOnX.cxx

SET objs=%bin%\G4Lab_UIOnX.obj

lib.exe /nologo /machine:ix86 /out:G4LabUIOnX.lib %objs%

DEL %objs%

REM #//////////////////////////////////////////////////
REM #// dll G4Lab :
REM #//////////////////////////////////////////////////
SET cppflags=%def_cppflags%
SET cppflags=%cppflags% /I..\source%
SET cppflags=%cppflags% %onx_cppflags%
SET cppflags=%cppflags% %onx_iv_cppflags%
SET cppflags=%cppflags% %aida_cppflags%
cl.exe /c %cppflags% /Fo%bin%\G4Lab_Callbacks.obj /Tp%src%\Callbacks.cxx

REM # Build the archive lib :
SET objs=%bin%\G4Lab_Callbacks.obj

lib.exe /nologo /machine:ix86 /out:%bin%\G4Lab.arc %objs%

DEL %objs%

REM # Build the win32def.exe utility program :
cl.exe %def_cppflags% /Fe%bin%\win32def.exe /Tpwin32def.c
DEL %bin%\win32def.obj

REM # Building the .def file :
dumpbin /out:%bin%\tmp /symbols %bin%\G4Lab.arc
%bin%\win32def.exe G4Lab < %bin%\tmp > %bin%\G4Lab.def

REM # Build the DLL :
lib.exe /nologo /machine:ix86 /def:%bin%\G4Lab.def /out:%bin%\G4Lab.lib
IF EXIST %bin%\G4Lab.dll DEL %bin%\G4Lab.dll

SET libs=
REM SET libs=%libs% %onx_iv_libs%
SET libs=%libs% %onx_libs%

link.exe /nologo /dll /out:%bin%\G4Lab.dll %bin%\G4Lab.exp %bin%\G4Lab.arc %libs%

DEL %bin%\tmp

ENDLOCAL
