#ifndef Lib_BaseAccessor_h
#define Lib_BaseAccessor_h

// Inheritance :
#include <Slash/Data/IAccessor.h>

#include <vector>

#include <Lib/Property.h>

namespace Slash {namespace Core {class IWriter;}}

namespace Lib {

class BaseAccessor : public virtual Slash::Data::IAccessor {
public: // IAccessor :
  virtual void* cast(const std::string&) const;
  virtual unsigned int numberOfProperties() const;
  virtual const Slash::Data::IProperty* property(unsigned int) const;
  virtual Slash::Data::IIterator* iterator();  
  virtual bool setName(const std::string&);
  virtual void setIterator(Slash::Data::IIterator*);  
  virtual void setIteratorArguments(const std::vector<std::string>&);  
  virtual void destroy(Slash::Data::IAccessor::Data,void*);
  virtual void set(Slash::Data::IAccessor::Data,const std::string&,
                   const std::string&,void*);
  virtual void calculate(Slash::Data::IAccessor::Data,const std::string&,
                         const std::vector<Slash::Core::IValue*>&,void*);
  virtual void setExecuteArguments(const std::vector<std::string>&);  
public:
  BaseAccessor(Slash::Core::IWriter&);
  virtual ~BaseAccessor();
  Slash::Core::IWriter& printer() const;
  const std::vector<std::string>& iteratorArguments() const;
  const std::vector<std::string>& executeArguments() const;
protected:
  void addProperty(const std::string&,Slash::Data::IProperty::Type,int = 0,const std::string& = "");
  void clearProperties();
private:
  std::vector<Property> fList;
  Slash::Core::IWriter& fPrinter;
  std::vector<std::string> fIteratorArgs;
  std::vector<std::string> fExecuteArgs;
};

}

#endif



