import OnX
from OnX import *

#/////////////////////////////////////////////////////////////////////////////
# page procedures :
#/////////////////////////////////////////////////////////////////////////////

def page_parameterValue(aWhat):
  page = ui.currentPage()
  ss = std_string('')
  if page.parameterValue(aWhat,ss) == 0 : return ''
  cs = ss.c_str()
  del ss
  return cs

#/////////////////////////////////////////////////////////////////////////////
# region procedures :
#/////////////////////////////////////////////////////////////////////////////

def region_parameterValue(aWhat):
  page = ui.currentPage()
  region = page.currentRegion()
  ss = std_string('')
  if region.parameterValue(aWhat,ss) == 0 : return ''
  cs = ss.c_str()
  del ss
  return cs

def region_findNode( aWhat, aValue ):
  page = ui.currentPage()
  region = page.currentRegion()
  rep = region.findRepresentation(aWhat,aValue)
  node = opaque_to_SoNode(rep.object())
  del rep;del region;del page
  return node

def region_setSize(aWidth=1,aHeight=1):
  page = ui.currentPage()
  assert page
  region = page.currentRegion()
  assert region
  region.setSize(aWidth,aHeight)
  del region;del page

def region_setPosition(aX=0,aY=0):
  page = ui.currentPage()
  assert page
  region = page.currentRegion()
  assert region
  region.setPosition(aX,aY)
  del region;del page

def region_dumpNode( aWhat, aValue ):
  page = ui.currentPage()
  assert page
  region = page.currentRegion()
  assert region
  rep = region.findRepresentation(aWhat,aValue)
  assert rep
  node = opaque_to_SoNode(rep.object())
  assert node
  ss = SbString('')
  node.get(ss)
  ui.echo(ss.getString())
  del rep;del node; del ss;del region;del page

def region_light():
  page = ui.currentPage()
  assert page
  region = page.currentRegion()
  assert region
  rep = region.findRepresentation('type','SoDirectionalLight')
  assert rep
  node = opaque_to_SoNode(rep.object())
  assert node
  del rep;del region;del page
  return node

def region_lightModel():
  page = ui.currentPage()
  assert page
  region = page.currentRegion()
  assert region
  rep = region.findRepresentation('type','SoLightModel')
  assert rep
  node = opaque_to_SoNode(rep.object())
  assert node
  del rep;del region;del page
  return node

def region_dumpCamera():
  region_dumpNode('type','SoCamera')

def region_camera():
  page = ui.currentPage()
  assert page
  region = page.currentRegion()
  assert region
  rep = region.findRepresentation('type','SoCamera')
  assert rep
  camera = opaque_to_SoNode(rep.object())
  assert camera
  del rep;del region;del page
  return camera

def region_setCamera(aHeight, aPosition, aOrientation):
  camera = region_camera()
  camera.set(aHeight)
  camera.set(aPosition)
  camera.set(aOrientation)
  del camera

def region_setCameraHeight(aHeight):
  camera = region_camera()
  camera.set('height %g' % aHeight)
  del camera

def region_setCameraPosition(aX,aY,aZ):
  camera = region_camera()
  camera.set('position %g %g %g' % (aX,aY,aZ))
  del camera

def region_setCameraNearFar(aNear,aFar):
  camera = region_camera()
  camera.set('nearDistance %g' % aNear)
  camera.set('farDistance %g' % aFar)
  del camera

def region_dynamicNode():
  page = ui.currentPage()
  assert page
  region = page.currentRegion()
  assert region
  rep = region.findRepresentation('name','dynamic')
  assert rep
  node = opaque_to_SoNode(rep.object())
  assert node
  del rep;del region;del page
  return SoNode_to_SoSeparator(node)

def region_staticNode():
  page = ui.currentPage()
  assert page
  region = page.currentRegion()
  assert region
  rep = region.findRepresentation('name','static')
  assert rep
  node = opaque_to_SoNode(rep.object())
  assert node
  del rep;del region;del page
  return SoNode_to_SoSeparator(node)

def region_applicationNode():
  page = ui.currentPage()
  assert page
  region = page.currentRegion()
  assert region
  rep = region.findRepresentation('name','application')
  assert rep
  node = opaque_to_SoNode(rep.object())
  assert node
  del rep;del region;del page
  return SoNode_to_SoSeparator(node)

def region_addFrame(aScale = 1, aColor = '1 1 0'):
  separator = SoSeparator()
  separator.setName('sceneGraph')
  # The highlight switch :
  soSwitch = SoNode_to_SoSeparator(SoSwitch())
  soSwitch.setName('highlight')
  separator.addChild(soSwitch)
  material = SoMaterial()
  material.set('diffuseColor %s' % aColor)
  soSwitch.addChild(material)
  highLightMaterial = SoMaterial()
  highLightMaterial.set('diffuseColor 1 1 1')
  soSwitch.addChild(highLightMaterial)
  soSwitch.set('whichChild 0')
  frame = SoCoordinateAxis()
  frame.setName('frame')
  frame.set('fNDivision 10')
  frame.set('fDivisionLength %g' % aScale)
  separator.addChild(frame)
  region_staticNode().addChild(separator)
  del separator;del soSwitch;del material;del highLightMaterial;del frame

def region_addGridFrame(aScale = 1):
  rep = representer.represent('InventorFile','','$ONXROOT/scripts/Inventor/frame.iv')
  assert rep
  rep.thisown = 1 # So that Python "del rep" delete the C++ IRepresentation.
  node = opaque_to_SoNode(rep.object())
  assert node
  separator = SoSeparator()
  separator.setName('sceneGraph')
  scale = SoScale()
  scale.set('scaleFactor %g %g %g' % (aScale,aScale,aScale) )
  separator.addChild(scale)
  separator.addChild(node)        
  region_staticNode().addChild(separator)
  del rep;del node;del scale;del separator

def region_readInventorFile(aFile):
  page = ui.currentPage()
  assert page
  region = page.currentRegion()
  assert region
  region.addRepresentation(representer.represent('InventorFile','static',aFile))
  del region;del page

def region_plotter():
  return region_findNode('type','SoPlotter')        

def region_connect(aIndex):
  currentRegionIndex = ui.currentPage().currentRegionIndex()
  if aIndex == currentRegionIndex : return
  ui.currentPage().setCurrentRegion(aIndex)
  staticNode = region_staticNode()
  dynamicNode = region_dynamicNode()
  ui.currentPage().setCurrentRegion(currentRegionIndex)
  connectingStaticNode = region_staticNode()
  connectingStaticNode.addChild(staticNode)
  connectingDynamicNode = region_dynamicNode()
  connectingDynamicNode.addChild(dynamicNode)
  # We rename the static, dynamic nodes of the "connecting" region
  # in order that adding a representation put the rep
  # in the "connected" region.
  connectingStaticNode.setName('staticConnected')
  connectingDynamicNode.setName('dynamicConnected')

