#ifndef OnXLab_PlotterMain_h
#define OnXLab_PlotterMain_h

// Inheritance :
#include <AIDA/IPlotterFactory.h>

#include <AIDA/IConstants.h> //For AIDA_VERSION

namespace OnXLab {

class Main;

class PlotterMain : public virtual AIDA::IPlotterFactory {
public: //AIDA::IPlotterFactory
#if (AIDA_VERSION_MAJOR<=3) && (AIDA_VERSION_MINOR<=2) 
  virtual AIDA::IPlotter* create(const std::string& aName = "");
#else
  virtual AIDA::IPlotter* create(const std::string& aName = "",
                                 const std::string& = "");
#endif
  virtual AIDA::IMarkerStyle* createMarkerStyle();
  virtual AIDA::ITextStyle* createTextStyle();
  virtual AIDA::ILineStyle* createLineStyle();
  virtual AIDA::IFillStyle* createFillStyle();
  virtual AIDA::IDataStyle* createDataStyle();
  virtual AIDA::IAxisStyle* createAxisStyle();
  virtual AIDA::ITitleStyle* createTitleStyle();
  virtual AIDA::IPlotterStyle* createPlotterStyle();
public:
  PlotterMain(int,char**);
  virtual ~PlotterMain();
  bool isValid() const;
private:
  Main* fAIDA;  
  AIDA::IPlotterFactory* fPlotterFactory;
};
}

#endif
