import AIDA
import random

aida = AIDA.createAnalysisFactory()

treeFactory = aida.createTreeFactory()
memoryTree = treeFactory.create()
del treeFactory
plotterFactory = aida.createPlotterFactory()
functionFactory = aida.createFunctionFactory(memoryTree)

# Get current plotter :
plotter = plotterFactory.create('')

plotter.createRegions(1,2,0)
plotter.setTitle('Complex')

import math

params = []
# Grid of dimension 1 :
params.append(1)
NX = 100
params.append(NX)
for I in range(0,NX):
 delta = 20./NX
 x = -10. + I * delta
 params.append(x)
# Real, imaginary part of values :
for I in range(0,NX):
 delta = 20./NX
 x = -10. + I * delta
 norme = math.sqrt(math.exp(-(x*x)/2))
 params.append(norme*math.cos(x))
 params.append(norme*math.sin(x))

# Then give 1 + 1 + NX + NX + NX values for parameters.

#FIXME : ComplexGrid1D is not an AIDA agreed function.
function = functionFactory.createFunctionByName('complexFunction','ComplexGrid1D')
#function.setTitle('sqrt(exp(-(x*x)/2))*(cos(x)+i*sin(x))')
function.setParameters(params)

region = plotter.currentRegion()
region.plot(function)

region.setParameter('plotter.xAxisAutomated','FALSE')
region.setParameter('plotter.xAxisMinimum','-10')
region.setParameter('plotter.xAxisMaximum','10')

region = plotter.next()

# xxx.convert_yyy are OnXLab SWIG extensions.
fr = function.convertToRealFunction(functionFactory,"real","Real part","real")
region.plot(fr)
del fr
fi = function.convertToRealFunction(functionFactory,"imag","Real part","imag")
region.plot(fi)
del fi
fn = function.convertToRealFunction(functionFactory,"norm","Real part","norm")
region.plot(fn)
del fn
fa = function.convertToRealFunction(functionFactory,"abs","Real part","abs")
region.plot(fa)
del fa

region.setParameter('plotter.xAxisAutomated','FALSE')
region.setParameter('plotter.xAxisMinimum','-10')
region.setParameter('plotter.xAxisMaximum','10')

plotter.show()
plotter.interact()

del region
del plotter
del params
del function
del functionFactory
del plotterFactory

del aida
