#ifndef AIDA_Loader_h
#define AIDA_Loader_h

#include <string>

namespace AIDA {

typedef void (*Procedure)();

class Loader {
public:
  Loader(const std::string& name,bool quiet = false,bool verbose = false);
  virtual ~Loader();
  bool open();
  Procedure find(const std::string&) const;
  const std::string& fileName() const;
  bool isOpened() const;
protected:
  void* fModule;
  std::string fName;
  std::string fError;
  bool fVerbose;
};

}

#endif




